@echo off
setlocal enableextensions enabledelayedexpansion

:SETUP
	call "!bat_exedir!\localize_GETDATE2_!bat_AUTOCAMS.locale!.bat"
	set bat_curdate=!bat_currdate!&	rem set bat_curdate=%date:~-10%
	if "%~1" neq "" (
		set bat_curdate=%~1
	)

	set bat_curdate=!bat_curdate:~-10!
	
	echo.%bat_curdate%|find /i "/">nul:
	if %errorlevel% equ 0 (
		echo for /f "delims=/ tokens=1-3" %%a in ^("!bat_curdate!"^) do ...
		for /f "delims=/ tokens=1-3" %%a in ("!bat_curdate!") do (
			echo %%a/%%b/%%c
			set bat_curm=0%%a
			set bat_curm=!bat_curm:~-2!
			set bat_curd=0%%b
			set bat_curd=!bat_curd:~-2!
			set bat_cury=20%%c
			set bat_cury=!bat_cury:~-4!
			set bat_year=!bat_cury:~-4!
		)
	) else (
		echo for /f "delims=_ tokens=1-3" %%a in ^("!bat_curdate!"^) do ...
		for /f "delims=_ tokens=1-3" %%a in ("!bat_curdate!") do (
			echo %%a/%%b/%%c
			set bat_curm=0%%b
			set bat_curm=!bat_curm:~-2!
			set bat_curd=0%%c
			set bat_curd=!bat_curd:~-2!
			set bat_cury=20%%a
			set bat_cury=!bat_cury:~-4!
			set bat_year=!bat_cury:~-4!
		)
	)

	call :date2jdate bat_JD !bat_cury! !bat_curm! !bat_curd!
	call :jdate2date !bat_JD! bat_yyyy bat_mm bat_dd

	rem         "(%a) % 7"          "(((!bat_JD!*100)/7)-(!bat_JD!/7*100)+1)*7/100"
	set /a bat_wdayn="(!bat_JD!) %% 7"
	if !bat_wdayn! equ 6 (
		set bat_weekday=Sunday
	) else (
		if !bat_wdayn! equ 0 (
			set bat_weekday=Monday
		) else (
			if !bat_wdayn! equ 1 (
				set bat_weekday=Tuesday
			) else (
				if !bat_wdayn! equ 2 (
					set bat_weekday=Wednesday
				) else (
					if !bat_wdayn! equ 3 (
						set bat_weekday=Thursday
					) else (
						if !bat_wdayn! equ 4 (
							set bat_weekday=Friday
						) else (
							if !bat_wdayn! equ 5 (
								set bat_weekday=Saturday
							)
						)
					)
				)
			)
		)
	)
	echo !bat_curdate!, !bat_yyyy!/!bat_mm!/!bat_dd!, JD=!bat_jd!, !bat_wdayn!, !bat_weekday!
rem set bat_
goto :EOF

	set bat_yyyy=%~1
	set bat_mm=%~2
	set bat_dd=%~3
	call :jdate2date !bat_jd! bat_yyyy bat_mm bat_dd
	call :date2jdate bat_jd !bat_yyyy! !bat_mm! !bat_dd!
	echo !bat_jd!
:MAIN

goto :DONE

set /a bat_num=%1

set /a bat_t1=((!bat_num!*1000)/7)
set /a bat_t2=(!bat_num!/7*1000)

set /a bat_t3=(!bat_t1!)-(!bat_t2)

set /a bat_wdayn=((!bat_num!*1000)/7)-(!bat_num!/7*1000)

if !bat_wdayn! equ 0 (
	set bat_weekday=Saturday
) else (
	if !bat_wdayn! equ 142 (
		set bat_weekday=Sunday
	) else (
		if !bat_wdayn! equ 
	)
)

goto :DONE



:date2jdate JD YYYY MM DD -- converts a gregorian calender date to julian day format
	rem                        -- JD   [out] - julian days
	rem                        -- YYYY [in]  - gregorian year, i.e. 2006
	rem                        -- MM   [in]  - gregorian month, i.e. 12 for december
	rem                        -- DD   [in]  - gregorian day, i.e. 31
call "!bat_exedir!\Date2JDate.bat"
EXIT /b 0




:jdate2date JD YYYY MM DD -- converts julian days to gregorian date format
	rem                     -- JD   [in]  - julian days
	rem                     -- YYYY [out] - gregorian year, i.e. 2006
	rem                     -- MM   [out] - gregorian month, i.e. 12 for december
	rem                      -- DD   [out] - gregorian day, i.e. 31
	call "!bat_exedir!\JDate2Date.bat"
EXIT /b 0



:DONE

